package router

import (
    "net/http"
    "nexus-server/users"
    "nexus-common/params"
    "github.com/labstack/echo/v4"
)

type RouterToken struct {
    users *users.Users
}

func NewRouterToken() *RouterToken {
    return &RouterToken{ users.GetUsersInstance() }
}

// Obtains a new access token.
// curl --cacert ca.pem -X GET http://localhost:1077/token/refresh -H "Authorization: Bearer <AccessToken>"
func (r *RouterToken)GetRefreshToken(c echo.Context) error {
    // Retrieves logged user from context.
    user, err := getLoggedUser(r.users, c)
    if err != nil {
        return echo.NewHTTPError(http.StatusUnauthorized, err.Error())
    }

    token, err := createToken(user.Email)
    if err != nil {
        return echo.NewHTTPError(http.StatusUnauthorized, err.Error())
    }

    return c.JSON(http.StatusOK, params.Token{Token:token})
}
